package com.smup.buffs;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;

import com.smup.ships.Vaisseau;

public abstract class Buff {
	protected Vaisseau m_owner;
	protected float m_duration;
	protected float m_timePassed = 0.f;
	
	public Buff(Vaisseau owner, float duration) {
		m_owner = owner;
		m_duration = duration;
	}
	
	public void render(Graphics g) {

	}
	
	public void update(int t) {
		effect(0.001f * t);
		
		if((m_timePassed += 0.001f * t) > m_duration) {
			onEnd();
		}
	}
	
	protected abstract void effect(float t);
	protected abstract void onEnd();
	public abstract Image getIcon();
	
	public float getDuration() { return m_duration - m_timePassed; }
}
