package com.smup.buffs;

import java.util.ArrayList;

import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;

public class BuffManager {
	private ArrayList<Buff> m_buffs;
	
	public BuffManager() {
		m_buffs = new ArrayList<Buff>();
	}
	
	public void update(int t) {
		for(int i = 0; i < m_buffs.size(); i++) {
			m_buffs.get(i).update(t);
		}
	}
	
	public void render(Graphics g) {
		for(Buff b : m_buffs) {
			b.render(g);
		}
	}
	
	public void add(Buff b) {
		m_buffs.add(b);
	}
	
	public void delete(Buff buff) {
		for(int i = 0; i < m_buffs.size(); i++) {
			if(buff == m_buffs.get(i))
				m_buffs.remove(i);
		}
	}
	
	public ArrayList<Image> getIcons() {
		ArrayList<Image> res = new ArrayList<Image>();
		
		for(Buff b : m_buffs) {
			res.add(b.getIcon());
		}
		
		return res;
	}
	
	public ArrayList<Float> getDurations() {
		ArrayList<Float> res = new ArrayList<Float>();
		
		for(Buff b : m_buffs) {
			res.add(b.getDuration());
		}
		
		return res;
	}
}
