package com.smup.buffs;

import org.newdawn.slick.Animation;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.SpriteSheet;

import com.smup.RessourceManager;
import com.smup.ships.Vaisseau;

public class Incendie extends Buff {
	protected float m_damagePerSec;
	protected float m_actualDamages = 0.f;
	protected Animation m_anim;
	
	public Incendie(Vaisseau owner, float duration, float damagePerSec) {
		super(owner, duration);
		m_anim = new Animation(new SpriteSheet(RessourceManager.getInstance().getImageByID("fire1"), 32, 45),
				 0, 0, 3, 0, true, 100, true);
		m_damagePerSec = damagePerSec;
	}
	
	@Override
	public void render(Graphics g) {
		float xP = m_owner.getX(), yP = m_owner.getY();
		m_anim.draw(xP - 4, yP - 33);
	}
	
	@Override
	protected void effect(float t) {
		if((m_actualDamages += m_damagePerSec * t) > 1) {
			m_owner.takeDamage((int) m_actualDamages);
			m_actualDamages = m_actualDamages - ((int) m_actualDamages);
		}
	}

	@Override
	protected void onEnd() {
		m_owner.deleteBuff(this);
	}

	@Override
	public Image getIcon() {
		return RessourceManager.getInstance().getImageByID("buff-incendie");
	}

}
