package com.smup.buffs;

import org.newdawn.slick.Animation;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.SpriteSheet;

import com.smup.RessourceManager;
import com.smup.ships.Vaisseau;

public class Regeneration extends Buff {
	
	private float mPvPerSec;
	protected float m_actualHeal = 0.f;
	protected Animation m_anim;
	
	public Regeneration(Vaisseau owner, float duration, float pvPerSec) {
		super(owner, duration);
		m_anim = new Animation(new SpriteSheet(RessourceManager.getInstance().getImageByID("heal1"), 32, 45),
				 0, 0, 3, 0, true, 200, true);
		mPvPerSec = pvPerSec;
	}

	@Override
	protected void effect(float t) {
		if((m_actualHeal += mPvPerSec * t) > 1) {
			m_owner.takeDamage(-(int) m_actualHeal);
			m_actualHeal = m_actualHeal - ((int) m_actualHeal);
		}
	}

	@Override
	protected void onEnd() {
		m_owner.deleteBuff(this);
	}
	
	@Override
	public void render(Graphics g) {
		float xP = m_owner.getX(), yP = m_owner.getY();
		m_anim.draw(xP, yP - 15);
	}

	@Override
	public Image getIcon() {
		return RessourceManager.getInstance().getImageByID("buff-heal");
	}

}
