package com.smup.entity;

import java.util.Random;

import org.newdawn.slick.Color;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.state.StateBasedGame;

public class Bullet extends Entity {
	
	private float m_x = 0, m_y = 0, m_vitesseX = 0, m_vitesseY = 0, m_vitesseScroll = 0;
	private int m_degats;

	public Bullet(float x, float y, float vitesseX, float vitesseY, float vitesseScroll, float precision, int degats) {
		m_x = x;
		m_y = y;
		m_vitesseX = vitesseX;
		m_vitesseY = vitesseY;
		m_vitesseScroll = vitesseScroll;
		m_degats = degats;
		
		Random rd = new Random();
		switch(rd.nextInt(2)) {
		case 0:
			m_vitesseY += rd.nextFloat() * 100 * (1.f - precision);
			break;
		case 1:
			m_vitesseY -= rd.nextFloat() * 100 * (1.f - precision);
			break;	
		}
	}
	
	@Override
	public void render(GameContainer gc, StateBasedGame sbg, Graphics g) {
		g.setColor(new Color(125, 125, 125));
		g.fillRect(m_x, m_y, 2, 2);
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbg, int t) {
		m_x += 0.001f * (m_vitesseX - m_vitesseScroll) * t;
		m_y += 0.001f * m_vitesseY * t;
	}
	
	public float getX() { return m_x; }
	public float getY() { return m_y; }	
	public void setVitesseScroll(float v) { m_vitesseScroll = v; }

	@Override
	protected void onDeath() {
		// TODO Auto-generated method stub
		
	}
	
	public int getDegats() { return m_degats; }
}
