package com.smup.entity;

import org.newdawn.slick.geom.Shape;

import com.smup.BasicStruct;
import com.smup.ships.Vaisseau;

public abstract class Entity implements BasicStruct {
	
	protected int m_id = -1; 
	protected float m_offset = 0.f;
	protected int m_vie = 100;
	protected int m_vieMax = 100;
	protected boolean m_canDie = false;
	protected boolean m_deadly = true;
	
	public void setID(int id) {
		m_id = id;
	}
	
	public int getID() { return m_id; }
	
	public Shape getHitbox() { return null; }
	
	public void setOffset(float o) { m_offset = o; }
	
	public void takeDamage(int amount) {
		m_vie -= amount;
		
		if(m_vie <= 0 && m_canDie) {
			onDeath();
		}
		
		if(m_vie > m_vieMax) {
			m_vie = m_vieMax;
		}
	}
	
	protected abstract void onDeath();
	public boolean isDeadly() { return m_deadly; }

	public void onPlayerCollision(Vaisseau joueur) {
		joueur.takeDamage(9999);
	}
}
