package com.smup.entity;

import org.newdawn.slick.Animation;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.state.StateBasedGame;

import com.smup.RessourceManager;
import com.smup.map.MapPart;

public class ShipExplosion extends Entity {
	
	MapPart m_owner;
	Animation m_anim;
	float m_x, m_y;
	
	public ShipExplosion(MapPart owner, float x, float y) {
		m_owner = owner;
		m_anim = new Animation(new SpriteSheet(RessourceManager.getInstance().getImageByID("shipExplosion"), 32, 32),
				 0, 0, 9, 0, true, 50, true);
		 m_anim.setLooping(false);
		 
		 m_x = x;
		 m_y = y;
		 
		 RessourceManager.getInstance().getSoundByID("expl1").play();
	}
	
	@Override
	public void render(GameContainer gc, StateBasedGame sbg, Graphics g) {
		m_anim.draw(m_x + m_offset, m_y);
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbg, int t) {
		if(m_anim.isStopped()) {
			m_owner.removeEntity(m_id);
		}
	}

	@Override
	protected void onDeath() {
	}
	
	@Override
	public Shape getHitbox() {
		return new Rectangle(0, 0, 0, 0);
	}

}
