package com.smup.map;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Random;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;

import org.newdawn.slick.SlickException;
import org.newdawn.slick.util.Log;
import org.w3c.dom.Document;
import org.w3c.dom.Element;
import org.w3c.dom.Node;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import com.smup.Constantes;
import com.smup.states.Map;

public class MapPartGenerator {
	
	private Random m_rd = new Random();
	
	private ArrayList<Zone> m_zones;
	private int m_idZoneActuelle;
	
	@SuppressWarnings("all")
	public MapPartGenerator() throws SlickException {
		m_zones = new ArrayList<Zone>();
	
		DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.newInstance();
		DocumentBuilder docBuilder = null;
		
		try {
			docBuilder = docBuilderFactory.newDocumentBuilder();
		} catch (ParserConfigurationException e) {
			throw new SlickException("Probleme lors du chargement des mapParts !", e);
		}
		
		Document doc = null;
		
		try {
			doc = docBuilder.parse(new File("data/map.xml"));
		} catch (SAXException e) {
			throw new SlickException("Probleme lors du chargement des mapParts !", e);
		} catch (IOException e) {
			throw new SlickException("Probleme lors du chargement des mapParts !", e);
		}
		
		doc.getDocumentElement().normalize();
		
		NodeList listZones = doc.getElementsByTagName("zone");
		int nbZones = listZones.getLength(); 
		
		for(int i = 0; i < nbZones; i++) {
			Node zoneNode = listZones.item(i);
			
			if(zoneNode.getNodeType() == Node.ELEMENT_NODE) {
				Element zoneElement = (Element)zoneNode;

				m_zones.add(new Zone(zoneElement));
			}
		}
		
		Log.debug("Const : " + Constantes.idZoneDepart);
		
		if(Constantes.idZoneDepart == -1)
			m_idZoneActuelle = m_rd.nextInt(m_zones.size());
		else
			m_idZoneActuelle = Constantes.idZoneDepart;
	}
	
	public MapPart getMapPart(Map map) {
		MapPart mp = m_zones.get(m_idZoneActuelle).getMapPart(map);
		
		if(mp == null) {
			// On change de zone !
			int nb = m_idZoneActuelle;
			
			while(nb == m_idZoneActuelle) {
				nb = m_rd.nextInt(m_zones.size());
			}
			
			m_idZoneActuelle = nb;
			return m_zones.get(m_idZoneActuelle).getMapPart(map);
		}
		
		return mp;
	}
	
	@SuppressWarnings("all")
	public void reset() {
		m_zones.get(m_idZoneActuelle).reset();
		
		if(Constantes.idZoneDepart == -1)
			m_idZoneActuelle = m_rd.nextInt(m_zones.size());
		else
			m_idZoneActuelle = Constantes.idZoneDepart;
	}
}
