package com.smup.ships;

import java.util.Random;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.state.StateBasedGame;

import com.smup.entity.Bullet;
import com.smup.entity.ShipExplosion;
import com.smup.map.MapPart;
import com.smup.states.Map;

public class FoeShip extends Ship {
	
	protected MapPart m_mapPart;
	protected float m_precision;
	
	public FoeShip(Map map, MapPart mapPart, float x, float y, int delayTir, float precision) {
		super(map, 0, delayTir, "foe-tourelle");
		m_mapPart = mapPart;
		m_precision = precision;
		
		m_vieMax = 200;
		m_vie = m_vieMax;
		
		m_sprite.setPosition(x, y);
		refreshHitbox();
	}
	
	public void update(GameContainer gc, StateBasedGame sbg, int t) {
		super.update(gc, sbg, t);
		
		if(m_peuxTirer) {
			tirer();
		}
	}	
	
	public void tirer() {
		m_map.addBullet(new Bullet(m_sprite.getX() + m_offset, 
								   m_sprite.getY() + m_sprite.getHeight() / 2, 
								   -150.f, 0.1f, m_map.getVitesseScroll(),
								   m_precision, 25), false);
		m_peuxTirer = !m_peuxTirer;
		m_tempsDepuisTir = 0;
	}
	
	public void setOffset(float o) {
		super.setOffset(o);
		refreshHitbox();
	}

	@Override
	protected void onDeath() {
		m_mapPart.addEntity(new ShipExplosion(m_mapPart, m_sprite.getX(), m_sprite.getY()));
		
		Random rd = new Random();
		
		if(rd.nextInt(3) == 2) {
			m_mapPart.addEntity(new RandomBonus(m_mapPart, m_sprite.getX(), m_sprite.getY()));
		}
		
		m_mapPart.removeEntity(m_id);
	}
}


