package com.smup.ships;

import java.util.Random;

import org.newdawn.slick.Animation;
import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.SpriteSheet;
import org.newdawn.slick.geom.Rectangle;
import org.newdawn.slick.geom.Shape;
import org.newdawn.slick.state.StateBasedGame;

import com.smup.RessourceManager;
import com.smup.buffs.Incendie;
import com.smup.buffs.Regeneration;
import com.smup.buffs.ShootRateModificator;
import com.smup.entity.Entity;
import com.smup.map.MapPart;

public class RandomBonus extends Entity {
	
	private Animation m_anim;
	private float m_x, m_y;
	private MapPart m_mapPart;
	
	public RandomBonus(MapPart mapPart, float x, float y) {
		m_mapPart = mapPart;
		m_x = x;
		m_y = y;
		m_deadly = false;
		
		m_anim = new Animation(new SpriteSheet(RessourceManager.getInstance().getImageByID("bonus"), 16, 16),
				 0, 0, 6, 0, true, 50, true);
	}
	
	@Override
	public void render(GameContainer gc, StateBasedGame sbg, Graphics g) {
		m_anim.draw(m_x + m_offset, m_y);
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbg, int t) {
		
	}
	
	@Override
	public void onPlayerCollision(Vaisseau v) {
		Random rd = new Random();
		int nb = rd.nextInt(3);
		
		if(nb == 1)
			v.addBuff(new Incendie(v, 5, 3));
		else if(nb == 2)
			v.addBuff(new ShootRateModificator(v, 15, 2));
		else
			v.addBuff(new Regeneration(v, 10, 3));
		
		onDeath();
	}
	
	@Override
	protected void onDeath() {
		m_mapPart.removeEntity(m_id);
	}
	
	@Override
	public Shape getHitbox() {
		return new Rectangle(m_x + m_offset, m_y, m_anim.getHeight(), m_anim.getWidth());
	}

}
