package com.smup.sprite;

import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;

import com.smup.RessourceManager;

public class Sprite {
	
	private Image m_image;
	String m_path = null;
	float m_x = 0, m_y = 0;
	
	public Sprite(String idImage) throws SlickException {
		m_image = RessourceManager.getInstance().getImageByID(idImage);
		m_path = idImage;
	}
	
	public Sprite(String path, float x, float y) throws SlickException {
		m_path = path;
		m_x = x;
		m_y = y;
	}
	
	public void draw() {
		m_image.draw(m_x, m_y);
	}
	
	public void draw(float x, float y) {
		m_image.draw(x, y);
	}
	
	public void setPosition(float x, float y) {
		m_x = x;
		m_y = y;
	}
	
	public void move(float x, float y) {
		m_x += x;
		m_y += y;
	}
	
	public float getX() { return m_x; }
	public float getY() { return m_y; }

        public int getHeight() {
                return m_image.getHeight();
        }

        public int getWidth() {
                return m_image.getWidth();
        }

        public void setFilter(int filter) {
                m_image.setFilter(filter);
        }

}
