package com.smup.states;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;

import com.smup.RessourceManager;

public class GameOver extends BasicGameState{
	public static final int ID = 2;
	
	private StateBasedGame m_sbg;
	private Image m_bg;
	private int m_nbCoupsTires;
	
	public GameOver(int nbCoupsTires) {
		m_nbCoupsTires = nbCoupsTires;
	}
	
	@Override
	public void init(GameContainer gc, StateBasedGame sbg)
			throws SlickException {
		m_sbg = sbg;
		
		// On charge l'image de fond
		m_bg = RessourceManager.getInstance().getImageByID("gameOver");
	}

	@Override
	public void render(GameContainer gc, StateBasedGame sbg, Graphics g)
			throws SlickException {
		m_bg.draw(0, 25);
		g.drawString("Nombre de tirs : " + m_nbCoupsTires, 250, 350);
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbg, int t)
			throws SlickException {
	}
	
	@Override
	public void keyReleased(int key, char c) {	
		m_sbg.enterState(MainMenu.ID, new FadeOutTransition(), new FadeInTransition());
	}
	
	@Override
	public int getID() {
		return ID;
	}
}
