package com.smup.states;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;

import com.smup.RessourceManager;

public class LoadingScreen extends BasicGameState {
	public static final int ID = 0;
	
	private RessourceManager rm = RessourceManager.getInstance();
	private Image m_bg, m_barBg, m_bar;
	private boolean m_estAffiche = false;
	
	@Override
	public void init(GameContainer arg0, StateBasedGame arg1)
			throws SlickException {
		m_bg = new Image("data/graphics/window/loading.png");
		m_barBg = new Image("data/graphics/window/loadingBarBg.png");
		m_bar = new Image("data/graphics/window/loadingBar.png");	
		
		// On prpare les ressources
		try {
			rm.loadRessources(new FileInputStream(new File("data/ressources.xml")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	@Override
	public void render(GameContainer arg0, StateBasedGame arg1, Graphics arg2)
			throws SlickException {
		m_bg.draw();
		m_barBg.draw(125, 225);
		m_bar.getSubImage(0, 0, (int) (((float)rm.getActualRessourcesLoad() / rm.getTotalRessourcesToLoad()) * 750), 50).draw(130, 230);
		
		if(rm.getActualRessourcesLoad() < rm.getTotalRessourcesToLoad()) {
			arg2.drawString("Chargement de : " + rm.getElementToLoad().getTextContent(), 135, 300);
		} else {
			arg2.drawString("Chargement des ressources lies aux cartes...", 135, 300);
		}
		
		m_estAffiche = true;
	}

	@Override
	public void update(GameContainer arg0, StateBasedGame arg1, int arg2)
			throws SlickException {
		if(rm.getActualRessourcesLoad() < rm.getTotalRessourcesToLoad()) {
			if(m_estAffiche) {
				rm.loadRessource();
				m_estAffiche = false;
			} 
		} else {
			if(m_estAffiche) {
				rm.loadMapRessources();
				
				arg1.addState(new MainMenu());
				arg1.getState(MainMenu.ID).init(arg0, arg1);
				arg1.addState(new PauseMenu());
				arg1.getState(PauseMenu.ID).init(arg0, arg1);
				arg1.addState(new Map());
				arg1.getState(Map.ID).init(arg0, arg1);
				
				arg1.enterState(MainMenu.ID, new FadeOutTransition(), new FadeInTransition());
			}
		}
	}

	@Override
	public int getID() {
		return ID;
	}

}
