package com.smup.states;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;
import org.newdawn.slick.util.Log;

import com.smup.RessourceManager;

public class MainMenu extends BasicGameState {
	
	public static final int ID = -1;
	
	private StateBasedGame m_sbg;
	private GameContainer m_gc;
	private Image m_bg;
	
	@Override
	public void init(GameContainer gc, StateBasedGame sbg)
			throws SlickException {
		m_sbg = sbg;
		m_gc = gc;
		
		RessourceManager rm = RessourceManager.getInstance();
		
		// On charge l'image de fond
		m_bg = rm.getImageByID("mainMenu");
		Log.debug("IMG : " + m_bg);
	}

	@Override
	public void render(GameContainer gc, StateBasedGame sbg, Graphics g)
			throws SlickException {
		m_bg.draw(0, 25);
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbg, int t)
			throws SlickException {
	}
	
	@Override
	public void keyReleased(int key, char c) {
		if(key == Input.KEY_ESCAPE) // ESCAPE pour quitter le jeu
		{
			m_gc.exit();
		} else {
			RessourceManager.getInstance().getMusicByID("bgm").loop(1, 0.75f);
			// On rinitialise la carte
			((Map) m_sbg.getState(Map.ID)).reset();
			m_sbg.enterState(Map.ID, new FadeOutTransition(), new FadeInTransition());
		}
	}
	
	@Override
	public int getID() {
		return ID;
	}
	
}
