package com.smup.states;

import org.newdawn.slick.GameContainer;
import org.newdawn.slick.Graphics;
import org.newdawn.slick.Image;
import org.newdawn.slick.Input;
import org.newdawn.slick.SlickException;
import org.newdawn.slick.state.BasicGameState;
import org.newdawn.slick.state.StateBasedGame;
import org.newdawn.slick.state.transition.FadeInTransition;
import org.newdawn.slick.state.transition.FadeOutTransition;

import com.smup.RessourceManager;

public class PauseMenu extends BasicGameState {
	public static final int ID = 10;
	
	private Image m_bg;
	private StateBasedGame m_sbg;
	
	@Override
	public void init(GameContainer gc, StateBasedGame sbg)
			throws SlickException {
		m_sbg = sbg;
		
		m_bg = RessourceManager.getInstance().getImageByID("pauseMenu");
	}

	@Override
	public void render(GameContainer gc, StateBasedGame sbg, Graphics g)
			throws SlickException {
		m_bg.draw();
	}

	@Override
	public void update(GameContainer gc, StateBasedGame sbg, int t)
			throws SlickException {	
		
	}

	@Override
	public int getID() {
		return ID;
	}
	
	@Override
	public void keyReleased(int key, char c) {
		if(key == Input.KEY_ESCAPE) // ESCAPE pour retourner au menu principal
		{
			m_sbg.enterState(MainMenu.ID, new FadeOutTransition(), new FadeInTransition());
		} else if (key == Input.KEY_SPACE){
			m_sbg.enterState(Map.ID, new FadeOutTransition(), new FadeInTransition());
			RessourceManager.getInstance().getMusicByID("bgm").resume();
		}
	}

}
